package 
{
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Shape;
  import flash.display.Sprite;
  import flash.display.StageScaleMode;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.filters.BlurFilter;
  import flash.geom.ColorTransform;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.media.Sound;
  import flash.ui.Keyboard;
  import flash.utils.Dictionary;


	public class Main extends xGame 
	{

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
  
    


  [Embed(source = "data/ball0.png")] private static var     embedPicBall0:Class;
  [Embed(source = "data/ball1.png")] private static var embedPicBall1:Class;
  [Embed(source = "data/ball2.png")] private static var embedPicBall2:Class;
  [Embed(source = "data/ball3.png")] private static var embedPicBall3:Class;
  [Embed(source = "data/playup0.png")] private static var embedPicPlayup0:Class;
  [Embed(source = "data/playup1.png")] private static var embedPicPlayup1:Class;
  [Embed(source = "data/playup2.png")] private static var embedPicPlayup2:Class;
  [Embed(source = "data/playup3.png")] private static var embedPicPlayup3:Class;
  [Embed(source = "data/shad.png")] private static var embedPicShad:Class;
  [Embed(source = "data/playside0.png")] private static var embedPicPlayside0:Class;
  [Embed(source = "data/playside1.png")] private static var embedPicPlayside1:Class;
  [Embed(source = "data/playside2.png")] private static var embedPicPlayside2:Class;
  [Embed(source = "data/playside3.png")] private static var embedPicPlayside3:Class;
  [Embed(source = "data/playdown0.png")] private static var embedPicPlaydown0:Class;
  [Embed(source = "data/playdown1.png")] private static var embedPicPlaydown1:Class;
  [Embed(source = "data/playdown2.png")] private static var embedPicPlaydown2:Class;
  [Embed(source = "data/playdown3.png")] private static var embedPicPlaydown3:Class;
  [Embed(source = "data/ball10.png")] private static var embedPicBall10:Class;



    [Embed(source = "minifont8.png")]  private static var embedFontPic8:Class;
    [Embed(source = "minifont8.xfnt", mimeType = "application/octet-stream")]
    private static var embedFont8:Class;
    public var myAdvFont:xAdvFont;
    
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      stage.quality = "LOW";
      stage.scaleMode = StageScaleMode.NO_SCALE;
 
      myAdvFont = new xAdvFont();
      myAdvFont.loadFont(embedFont8, embedFontPic8);

      mySound2 = new xSoundMan();
   
      dictPic["ball0"] = (new embedPicBall0).bitmapData;
      dictPic["ball1"] = (new embedPicBall1).bitmapData;
      dictPic["ball2"] = (new embedPicBall2).bitmapData;
      dictPic["ball3"] = (new embedPicBall3).bitmapData;
      dictPic["playup0"] = (new embedPicPlayup0).bitmapData;
      dictPic["playup1"] = (new embedPicPlayup1).bitmapData;
      dictPic["playup2"] = (new embedPicPlayup2).bitmapData;
      dictPic["playup3"] = (new embedPicPlayup3).bitmapData;
      dictPic["shad"] = (new embedPicShad).bitmapData;
      dictPic["playside0"] = (new embedPicPlayside0).bitmapData;
      dictPic["playside1"] = (new embedPicPlayside1).bitmapData;
      dictPic["playside2"] = (new embedPicPlayside2).bitmapData;
      dictPic["playside3"] = (new embedPicPlayside3).bitmapData;
      dictPic["playdown0"] = (new embedPicPlaydown0).bitmapData;
      dictPic["playdown1"] = (new embedPicPlaydown1).bitmapData;
      dictPic["playdown2"] = (new embedPicPlaydown2).bitmapData;
      dictPic["playdown3"] = (new embedPicPlaydown3).bitmapData;
      dictPic["ball10"] = (new embedPicBall10).bitmapData; 
      
      
        vecAct = new Vector.<xAct>(0,false);
            var i:int; var a:xAct;
            for(i=0;i<32;i+=1)
            {
              a = new xAct();
               a.cx = Math.random()*512;
               a.cy = Math.random()*1024;
              vecAct.push(a); 
             if (i > 16) { a.team = 1; }
 
            }//nexti 
            

      stage.addEventListener(MouseEvent.MOUSE_DOWN, onMdown);
      stage.addEventListener(MouseEvent.MOUSE_UP, onMup);
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKdown);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKup);
      stage.addEventListener(Event.ENTER_FRAME, onEnter);   
		}//init

    public var dictPic:Dictionary = new Dictionary();
    public function getData(wname:String):BitmapData { return dictPic[wname]; }
    
    public var mySound2:xSoundMan;
    public function playSound(wname:String, vm:Number = 1.0, pan:Number = 0.0):void 
    {  mySound2.playSound(wname, vm, 0);  }
  
     // public var camx:Number = 0;
      //public var camy:Number = 0;
        
        public var cx:Number = 230;
        public var cy:Number = 230;
        public var cz:Number = 0;
        public var vx:Number = 0;
        public var vy:Number = 0;
        public var vz:Number = 0;
        
        public var vecAct:Vector.<xAct>;
        
        public function getMag(ax:Number, ay:Number):Number
        { return Math.sqrt(ax*ax+ay*ay); } 
    

        
    public function checkGoal(ax:Number, ay:Number, aw:Number, ah:Number):Boolean
    {
         fillRect(canvas, ax - camx, ay - camy, aw, ah, 0x114020);
        return ((cx<ax||cx>ax+aw||cy<ay||cy>ay+ah)==false);
        
    }//endif
        
    public function onEnter(e:Event):void
    {  
         
      mx = stage.mouseX; my = stage.mouseY;
      wmx = mx+camx; wmy = my+camy;
      
      
        graphics.clear();
        
        canvas.unlock();
          graphics.beginBitmapFill(canvas, null, false, false); 
           graphics.drawRect(0, 0, 640, 480);
          graphics.endFill();
        canvas.lock();
 
        canvas.fillRect(canvas.rect, 0x118020);

        //fillRect(canvas, 192 - camx, 0 - camy, 128, 64, 0xFFffFFff);
        //fillRect(canvas, 192 - camx, (1024 - 64)  - camy, 128, 64, 0xFFffFFff);
        if (checkGoal(192, 0, 128, 64)) { cx = 256; cy = 512; }
        if (checkGoal(192, 1024-64, 128, 64)) { cx = 256; cy = 512; }

        drawRect(canvas, 0 - camx, 0 - camy, 512, 1024, 0xFFffFF);
        
        drawRect(canvas, 128 - camx, 0 - camy, 256, 128, 0xFFffFF);
        drawRect(canvas, 128 - camx, (1024-128) - camy, 256, 128, 0xFFffFF);
        
        fillRect(canvas, 0 - camx, 512 - camy, 512, 2, 0xFFffFF);
        
        drawRect(canvas, 128 - camx, (512-128) - camy, 256, 256, 0xFFffFF);
        
        fillRect(canvas, (256-8) - camx, (512-8) - camy, 16, 16, 0xFFffFF);
        
        
        num = vecAct.length;
        for(i=0;i<num;i+=1)
        {
          a = vecAct[i];
            drawSprite(canvas, getData("shad"), a.cx - camx+1, a.cy - camy+6, true); 
        }//nexti
   
        drawSprite(canvas, getData("shad"), cx - camx, cy - camy, true); 
        
        num = vecAct.length;
        for(i=0;i<num;i+=1)
        {
          a = vecAct[i];
          
          if (Math.abs(a.vx) > 0  && Math.abs(a.vy)>0)
           {  k = (int((gt + i) / 8) % 4); }
           else { k = 0; }
          
         
          if (Math.abs(a.vx) > Math.abs(a.vy))
          {
            drawSprite(canvas, getData("playside" + k), a.cx - camx, a.cy - camy - a.cz, true, a.vx < 0);   
               continue;
          }
          else 
          {
            if (a.vy < 0)
            { drawSprite(canvas, getData("playup"+k), a.cx - camx, a.cy - camy - a.cz, true);     }
            else            
            { drawSprite(canvas, getData("playdown"+k), a.cx - camx, a.cy - camy - a.cz, true);     }
     
            continue;
          }//endif
          
            drawSprite(canvas, getData("playdown0"), a.cx - camx, a.cy - camy - a.cz, true); 
          
        }//nexti

        i = (int(gt / 8) % 3) + 1;
            drawSprite(canvas, getData("ball"+i), cx - camx, cy - camy - cz, true); 
        
        
        
       
        
         graphics.lineStyle(2, 0);
            
           // graphics.drawRect(0-camx,0-camy,512,1024);
            
            
            var a:xAct;
            var i:int; var num:int;
            num = vecAct.length;
            for(i=0;i<num;i+=1)
            {
              a = vecAct[i];
              
              var ms:Number; var ta:Number;
                  ta = Math.atan2(cy - a.cy, cx - a.cx);
                  if (a.team==1) {  ta = Math.atan2(wmy - a.cy, wmx - a.cx); }
                  ms =0.3;
                  a.vx += Math.cos(ta) * ms;
                  a.vy += Math.sin(ta)*ms;
                  ms = 3;
                   if (a.vx>ms){a.vx=ms;} else if (a.vx<-ms){a.vx=-ms;}
                   if (a.vy>ms){a.vy=ms;} else if (a.vy<-ms){a.vy=-ms;}
                   
                if (getMag(a.cx-cx,a.cy-cy)<16)
                if (Math.abs(cz-a.cz)<8)
                {
                  ms =0.6 + Math.random()*6;
                  vx += Math.cos(ta) * ms;
                  vy += Math.sin(ta)*ms;
                  vz = Math.random()*2;
                  ms = 8;
                   if (vx>ms){vx=ms;} else if (vx<-ms){vx=-ms;}
                   if (vy>ms){vy=ms;} else if (vy<-ms){vy=-ms;}
                }//endif   
                  
              var k:int; var b:xAct;
              for (k=i+1;k<num;k+=1)
              {
                 b = vecAct[k];
                 var d:Number; var dx:Number; var dy:Number;
                 dx=a.cx-b.cx; dy=a.cy-b.cy;
                 d = getMag(dx, dy);
                 if (d==0){continue;}
                 if (d<16)
                 { dx/=d; dy/=d;
                   a.vx+=dx; a.vy+=dy;
                   b.vx-=dx; b.vy-=dy;
                 }//endif
              }//nextk
              
              if (a.cy<0&&a.vy<0) { a.vy=-a.vy; a.cy=0; }
              if (a.cy>1024&&a.vy>0) { a.vy=-a.vy; a.cy=1024; }
              if (a.cx<0&&a.vx<0) { a.vx=-a.vx; a.cx=0; }
              if (a.cx>512&&a.vx>0) { a.vx=-a.vx; a.cx=512; }
              
              a.cx+=a.vx; a.cy+=a.vy;
              /*
                 graphics.drawEllipse(a.cx-8-camx,a.cy-2-camy+8,16,4);
                 graphics.beginFill(0xFFffFF,1);
                 graphics.drawCircle(a.cx-camx,a.cy-camy-a.cz, 8);
                 graphics.endFill();
                */
            }///nexti

            /*
            graphics.drawEllipse(cx-8-camx,cy-2-camy+8,16,4);
            graphics.beginFill(0x808080,1);
            graphics.drawCircle(cx-camx,cy-camy-cz, 8);
            graphics.endFill();
            */
            
            vx*=0.97;        vy*=0.97;
            vz -=0.1;
            
              if (cy<0&&vy<0) { vy=-vy; cy=0; }
              if (cy>1024&&vy>0) { vy=-vy; cy=1024; }
              if (cx<0&&vx<0) { vx=-vx; cx=0; }
              if (cx>512&&vx>0) { vx=-vx; cx=512; }
              if (cz<0&&vz<0){vz*=-0.5;  cz=0;}

            cx+=vx; cy+=vy; cz+= vz;
            
            gt += 1;
            
            a = vecAct[17];
            camx = a.cx-235;
            camy = a.cy - 235; 
            
            if (camx < -128) { camx = -128; }
            if (camx > 8) { camx =  8; }
            ms = 32;
           
            if (camy < -ms) { camy = -ms; }
            if (camy > (1024-480 + ms)) { camy= 1024-480 + ms; }
            
  
    }//onenter
    

  
  
  
  }//classend
}


internal class xAct
{
  public var cx:Number = 0;
  public var cy:Number = 0;
  public var cz:Number = 0;
  
  public var vx:Number = 0;
  public var vy:Number = 0;   
  public var col:uint = 0xFFffFF;
  
  public var team:int = 0;
  
    
};//xact

  







