package  
{
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Shape;
  import flash.display.Sprite;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.geom.ColorTransform;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.utils.Dictionary;

  public class xGame extends Sprite
  {
     
    public var mx:Number = 0;    public var my:Number = 0;
    public var wmx:Number = 0;    public var wmy:Number = 0;
    public var camx:Number = 0;    public var camy:Number = 0;
  
    public var canvas:BitmapData = new BitmapData(640, 480, false, 0);
    public var gt:int = 0;

    public var world_width:Number = 640;
    public var world_height:Number = 480;

      public var vecPress:Vector.<int>= new Vector.<int>(512, false);
      public var keyTime:int = 1;     public var mbutton:int = 0; 
      public var mpress:int = 0;    public var mclick:int = 0;   
      public var mstart:int = 0; public var mtime:int = 0;
      public var lastKeyTime:int = 0;
   
      public var vecKey:Vector.<Boolean> = new Vector.<Boolean>(512, false);
      public function onKdown(e:KeyboardEvent):void { vecKey[e.keyCode] = true;
      vecPress[e.keyCode] = keyTime; lastKeyTime = keyTime; }    
      public function onKup(e:KeyboardEvent):void  { vecKey[e.keyCode] = false; }
      public function isKeyDown(k:int):Boolean { return vecKey[k]; }  
      public function isKeyPress(k:int):Boolean { return vecPress[k] == keyTime; }
      
      public function onMdown(e:MouseEvent):void { mbutton = 1; mpress = keyTime;  mstart = gt; }
      public function onMup(e:MouseEvent):void { mbutton = 0; mclick = keyTime; mtime = gt-mstart; }
      public function isMouseDown():Boolean { return (mbutton > 0); }
      public function isMousePress():Boolean { return (mpress == keyTime); }
      public function isMouseClick():Boolean { return (mclick == keyTime); }


      public var tempMat:Matrix = new Matrix();
    public var mirMat:Matrix = new Matrix();
    public function drawImageSpr(g:Graphics, spr:BitmapData, ax:Number, ay:Number, rep:Boolean=false, smooth:Boolean=false):void
    {
      tempMat.a = 1; tempMat.d = 1;
      tempMat.tx = ax;      tempMat.ty = ay;
      g.beginBitmapFill(spr, tempMat, rep, smooth);
        g.drawRect(ax, ay, spr.width, spr.height);
      g.endFill();     
    }//drawimagespr
    
    public function drawSpriteSpr(g:Graphics, spr:BitmapData, ax:Number, ay:Number, rep:Boolean=false, smooth:Boolean=false, xmir:Boolean=false, ymir:Boolean=false):void
    {
        ax -= spr.width * 0.5;        ay -=   spr.height * 0.5;
        mirMat.b = 0; mirMat.c = 0;
        mirMat.a = xmir ? -1 : 1;        mirMat.d = ymir ? -1 : 1;
        mirMat.tx = (ax + (xmir?spr.width:0))|0; mirMat.ty = (ay + (ymir?spr.height:0))|0;
       g.beginBitmapFill(spr, mirMat, rep, smooth);
        g.drawRect(mirMat.tx, mirMat.ty, spr.width, spr.height);
       g.endFill();             
    }//drawsprite

    public var tempRect:Rectangle = new Rectangle(0,0,0,0);  
    public function fillRect(to:BitmapData, ax:Number, ay:Number, aw:Number, ah:Number, c:uint):void
    {
       ax |= 0; ay |= 0;
        tempRect.x = ax; tempRect.y = ay;        tempRect.width = aw; tempRect.height = ah;
        to.fillRect(tempRect, c);
    }//drawrect
    
    public function drawRect(to:BitmapData, ax:Number, ay:Number, aw:Number, ah:Number, c:uint):void
    {
      ax |= 0; ay |= 0; aw |= 0; ah |= 0;
        tempRect.x = ax; tempRect.y = ay;        tempRect.width = 1; tempRect.height = ah;
        to.fillRect(tempRect, c);
        tempRect.x = ax+aw-1; tempRect.y = ay;        tempRect.width = 1; tempRect.height = ah;
        to.fillRect(tempRect, c);
        tempRect.x = ax; tempRect.y = ay;        tempRect.width = aw; tempRect.height = 1;
        to.fillRect(tempRect, c);
        tempRect.x = ax; tempRect.y = ay+ah-1;        tempRect.width = aw; tempRect.height = 1;
        to.fillRect(tempRect, c);
    }//drawrect

    public var dp:Point = new Point();
    public function drawImage(to:BitmapData, spr:BitmapData, ax:Number, ay:Number, merge:Boolean=false):void
    {
      if (ax < -spr.width) { return; }      if (ay < -spr.height) { return; }
      if (ax > to.width) { return; }      if (ay > to.height) { return; }
      dp.x = ax;        dp.y = ay;      to.copyPixels(spr, spr.rect, dp, null,null,merge); 
    }//drawimage
    
    // public var dp:Point = new Point();
   // public var mirMat:Matrix = new Matrix(1, 0, 0, 1, 0, 0);
    public function drawSprite(to:BitmapData, spr:BitmapData, ax:Number, ay:Number,
    merge:Boolean=true, xmir:Boolean=false, ymir:Boolean=false):void
    {
        var aw:Number;        var ah:Number;        aw = spr.width * 0.5;        ah = spr.height * 0.5;
        if (to.width < ax - aw) { return; }        if (to.height < ay - ah) { return; }
        if (0 > ax + aw) { return; }        if (0 > ay + ah) { return; }
        dp.x = ax-aw;        dp.y = ay - ah;
        if (xmir||ymir) { 
            mirMat.b = 0; mirMat.c = 0;            mirMat.a = xmir ? -1 : 1;            mirMat.d = ymir ? -1 : 1;
            mirMat.tx = (dp.x + (xmir?aw+aw:0))|0; mirMat.ty = (dp.y + (ymir?ah+ah:0))|0;
            to.draw(spr, mirMat, null, null, null, false); 
            return;
          }//endif
        to.copyPixels(spr, spr.rect, dp,null,null, merge); 
    }//drawsprite

    public function drawSprite2(to:BitmapData, spr:BitmapData, ax:Number, ay:Number,
    ang:Number = 0, xmir:Boolean = false, ymir:Boolean = false,
    scalex:Number = 1.0, scaley:Number = 1.0,
    blend:String = null, trans:ColorTransform=null, smooth:Boolean=false):void
     {
          var aw:Number;        var ah:Number;         var rad:Number;
          rad = spr.width > spr.height ? spr.width : spr.height;     
          if (to.width < ax - rad) { return; }        if (to.height < ay - rad) { return; }
          if (0 > ax + rad) { return; }        if (0 > ay + rad) { return; }
          aw = spr.width * 0.5;        ah = spr.height * 0.5;      
          mirMat.identity();  
          mirMat.tx = -aw; mirMat.ty = -ah;
          //fix (should mirror before rotate -- (how this affects xy scale?) (seems to be ok)
          mirMat.scale(xmir? -scalex:scalex, ymir? -scaley:scaley );  
          mirMat.rotate(ang);        
          mirMat.translate( ax, ay );  
          to.draw(spr, mirMat, trans, blend, null, smooth); 
     }//drawsprite2

     
     public var tempPnt:Point = new Point();
      public function drawTiledPattern(to:BitmapData, img:BitmapData, sx:Number, sy:Number, merge:Boolean=false):void
      {
        var startx:Number;        var tx:int;        var ty:int;        var dest:Point;    
        dest = tempPnt;
        startx = -(sx % img.width)  - img.width;
        tx = Math.floor(startx);   ty = Math.floor(-(sy % img.height) - img.height);
        while (ty < to.height)
        { while (tx < to.width)
          {
            dest.x = tx;            dest.y = ty;
            to.copyPixels(img, img.rect, dest, null, null, merge);              
            tx += img.width;
          }//wendx
          tx = startx; ty += img.height;
        }//wendy
      }//drawtiled


    public var tempShape:Shape = new Shape();
    public function drawLine(to:BitmapData,  x0:Number, y0:Number, x1:Number, y1:Number, c:uint, r:Number=1, blend:String=null):void
    { 
      var g:Graphics;
      g = tempShape.graphics;   
      g.clear();  g.lineStyle(r, c);   g.moveTo(x0, y0);   g.lineTo(x1, y1);      
      to.draw(tempShape, null, null, blend, null, false);           
    }//drawline
    
    public var fallShape:Shape = new Shape();
    public var fallMat:Matrix = new Matrix();
    public function drawFall(to:BitmapData, spr:BitmapData,
    ax:Number, ay:Number, aw:Number, ah:Number, tx:Number=0, ty:Number = 0, blend:String=null):void
    {
      var g:Graphics;      g = fallShape.graphics;
      fallMat.identity(); fallMat.tx=tx; fallMat.ty = ty;
      g.clear();      
      g.beginBitmapFill(spr, fallMat, true, false);
        g.drawRect(ax, ay, aw, ah);
      g.endFill();
      to.draw(fallShape,null,null, blend, null,false);
    }//drawfall

    public var dp_temprect:Rectangle = new Rectangle();
    public function drawPortion(to:BitmapData, spr:BitmapData, ax:Number, ay:Number, bx:Number, by:Number, bw:Number, bh:Number):void
    {
      dp_temprect.x = bx;      dp_temprect.y = by;      dp_temprect.width = bw;      dp_temprect.height = bh;
      dp.x = ax;        dp.y = ay;      to.copyPixels(spr, dp_temprect, dp); 
    }//drawport
    

  
    

      
  }//classend

}